<?xml version="1.0"?>

<st-source>
<!-- Changes in change set RA801604 -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on February 25, 2010 at 12:49:08 pm</time-stamp>


<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="doEvent:">doEvent: event 
	
	^self 
		doEvent: event
		timestamp: nil</body>

<body package="SAM-Interface" selector="doEvent:timestamp:">doEvent: event timestamp: timeInSeconds 

	self doInventoryChange: 
			[
			[self updateModelInterfaceWithTimestamp: timeInSeconds.
			self eventCallback value: event] 
					on: Error
					do: [:ex | self logEventProcessingError: ex]].
	^self</body>

<body package="SAM-Interface" selector="processXmlEvent:objectType:eventType:objectName:">processXmlEvent: anElement
	objectType: anObjectType
	eventType: anEventType
	objectName: anObjectName
	
	| eventColl |
	(eventColl := OrderedCollection new)
		add: anEventType;
		add: anObjectType;
		add: anObjectName.
	self 
		processFilteredXmlEvent: anElement
		eventType: anEventType
		into: eventColl.
	self 
		doEvent: eventColl
		timestamp: (self getTimestampFromXmlEvent: anElement).
	^eventColl</body>

<body package="SAM-Interface" selector="updateModelInterfaceWithTimestamp:">updateModelInterfaceWithTimestamp: timestamp 
	
	timestamp ifNotNil: 
		[self currentApplication server firstAdaptor modelInterface currentDate: timestamp]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>private</category>

<body package="SAM-Interface" selector="getTimestampFromXmlEvent:">getTimestampFromXmlEvent: xml 
	
	^((XML.XPathParser parse: '//MTOSI_osTime') 
		xpathValueFor: xml
		variables: #()) xpathAsString asNumber // 1000</body>
</methods>


<methods>
<class-id>PROVISO.PvDomainObject</class-id> <category>comparing</category>

<body package="PV-DM-Support" selector="matches:using:equality:">matches: aDomainObject using: aspects equality: equalityValuable 
	"aspects can be a collection of symbols or blocks"
	
	aDomainObject ifNil: [^false].
	self == aDomainObject 
		ifTrue: [^true].
	^aspects allSatisfy: 
		[:each | 
		(each value: self) 
			ifNil: [true]
			ifNotNil: 
				[:value | 
				equalityValuable 
					value: value
					value: (each value: aDomainObject)]]</body>
</methods>


<methods>
<class-id>PROVISO.PvBaseSubelement</class-id> <category>api</category>

<body package="PV-DM-Support" selector="smeeAlias">smeeAlias

	&lt;getterNamed: #alias comment: 'Get the alias for the receiver.'&gt;
	^self aliasName ifNil: [self name]</body>
</methods>

<methods>
<class-id>PROVISO.PvBaseSubelement</class-id> <category>compressing</category>

<body package="PVAdaptor Core" selector="mergeAttributesWith:">mergeAttributesWith: se2 

	self == se2 ifTrue: [^self].
	se2 name isNil ifFalse: [self name: se2 name].
	se2 state isNil ifFalse: [self state: se2 state].
	se2 aliasName isNil ifFalse: [self aliasName: se2 aliasName].
	self aliasName ifNil: [self aliasName: self name].
	se2 nclId notNil ifTrue: [self nclId: se2 nclId].
	^self</body>
</methods>


<methods>
<class-id>PROVISO.PvUniversalOutputWriter</class-id> <category>initialize-release</category>

<body package="PV-NM-Inventory-Application" selector="endWriteElement:onInsertDo:">endWriteElement: anElement onInsertDo: aPostInsertBlock 
	
	| elmt |
	elmt := 
		self pvModel elementManager 
			itemNamed: anElement name
			ifPresent: 
				[:el | 
				anElement collectorNumber ifNil: [anElement collectorNumber: el collectorNumber].
				(anElement 
					matches: el
					using: self elementAspects
					equality: 
						[:a :b | 
						a 
							ifNil: [true]
							ifNotNil: [a = b]]) 
								ifFalse: 
									[el mergeAttributesWith: anElement.
									el date: anElement date.
									self bulkInserter addUpdatedElement: el.
									self owner statistics incrementNumberOfUpdatedElementsBy: 1].
				el]
			ifAbsent: 
				[| anE |
				anE := self insertNewElement: anElement.
				aPostInsertBlock value: anE.
				anE].
	self 
		copyPropertiesFrom: anElement
		to: elmt.
	^elmt</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UniversalModelInterface</class-id> <category>actions</category>

<body package="PVAdaptor-New Generation" selector="flushInventory">flushInventory
	
	self owner critical: [self outputWriter flushAll].</body>
</methods>


<methods>
<class-id>PROVISO.UBA.Subelement</class-id> <category>initialize</category>

<body package="PVAdaptor Core" selector="initialize">initialize

	super initialize.
	self 
		state: #on;
		properties: (Dictionary new: 16);
"		metrics: Dictionary new;"
"		thresholds: OrderedCollection new;"
		type: 'fixed' ;
		username: self system systemSupport getUsername
		"date: PvTimestamp nowAsSeconds ;
			don't set date or OutputWriter will break - nil date means use date
			from previous object"</body>
</methods>



</st-source>
